<?php/* linux-log-sorter
... is a tool for rename and sort apache (and other) log files (.gz only)
!!! Please test it first with comment-out the rename-/unlink-/mkdir-lines !!!

To create the lognames.txt you can a command like this:
ls -l --color=never /var/www/virtual/|cut -b 50-100>lognames.txt

Make sure, that you add your subdomains (manually) BEFORE the domain!
 
Copyright (c) 2010 proteino.de, Norbert Schroeder

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the license, or at your option any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRENTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
675 Mass Ave, Cambridge, MA 02139, USA.
*/

$monthly=true;			    // set true to get monthly directories
$arr_log=@file("lognames.txt");
$logdir="/var/log/apache2/";        // set other dir, for instance for lighttpd
date_default_timezone_set('Europe/Berlin'); // this is needed since php 5.1

if(!(chdir($logdir)))die("$logdir not found\n");
foreach($arr_log as $log){
 $logname=trim($log);
 echo"$logname is located in $logdir\n";
 if($handle=opendir(".")){
  while(false!==($file=readdir($handle)))
   if((strpos($file,$logname)!==false)&&(strpos($file,$logname)==0)&&(strpos($file,".gz")!==false)){// only *.gz and files beginning with the domainname
   if((strpos($file,"combined.log")!==false)||(strpos($file,"access.log")!==false)){	// look at your log-names and change it if necessary
    $filenewname="$logname-".date("YmdHm",filemtime($file)).".gz";
    $logdirnew="$logdir$logname/".date("Y",filemtime($file))."/";
    if($monthly)$logdirnew.=date("m",filemtime($file))."/";
    echo"$file moved to $logdirnew$filenewname\n";
    @mkdir($logdirnew,0777,true);
    rename($file,$logdirnew.$filenewname);
   }else if(strpos($file,"error.log")!==false){
    echo"$file deleted\n";
    unlink($file);
   }else echo"$file untouched\n";
  }
  closedir($handle);
 }
}
?>
